/**
 * @author v_wangyan
 * @date 2012-11-05
 */ 
var skin = window.skin || {};
/**
 * 获取元素对象
 * @param  {string} element 元素id
 * @return {object}         返回元素对象
 */
skin.g = function(element) {
    return document.getElementById(element) || element;
},
/**
 * 转换JSON对象
 * @param  {string} jsonString json字符串
 * @return {object}            json对象
 */
skin.jsonDecode =function(jsonString) {
	return (new Function("return " + jsonString))();
},
/**
 * 显示dom
 * @param  {string} id dom的id
 * @return {void}    无
 */

skin.show = function(id) {
	skin.isShow(id, true);
},
/**
 * 隐藏dom
 * @param  {string} id dom的id
 * @return {void}    无
 */
skin.hide = function(id) {
    skin.isShow(id, false);
},
/**
 * 是否显示
 * @return {bool} 返回布尔值
 */
skin.isShow = function() {
    skin.g(id).style.display = flag ? 'block' : 'none';
},
/**
 * 添加样式
 * @param {string|object} element   目标元素
 * @param {string} className 样式名称
 */
skin.addClass = function(element, className) { 
	element = skin.g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
},
/**
 * 移除样式
 * @param  {string|object} element   目标元素
 * @param  {string} className 样式名称
 * @return {void}           无
 */
skin.removeClass = function(element, className) { 
	element = skin.g(element)||element; 

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;  
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
},
/**
 * 设置字体
 * @param {int}   
 * @return void
 */
skin.setFontFamily = function (key) {   //设置字体:  0-宋体 ; 1-微软雅黑;
    key = key || '0';
    var obj = document.body;
    var font = '';
    if (key) {
        font = '"微软雅黑", "宋体", Arial, Verdana';
    } else {
        font = '"宋体", "微软雅黑", Arial, Verdana';
    }
    obj.style.fontFamily = font;
}
/**
 * 设置页面显示的字体(win7--雅黑字,其他为宋体)
 * @param 无
 * @return string
 */
skin.getSysver = function () {
    var key = 0;
    try {
        key = execOrder('sysver');
        if ('6.1' == key) {
            key = 1;
        }
    } catch (e) {   }   
    
    skin.setFontFamily(key); 
}
/**
 * 处理icon点击
 * @param  {event} e          事件
 * @param  {bool} rightClick 是否为右键(点击)
 * @param  {number} key        iconid
 * @return {void}            无
 */
skin.execMouseDown = function (e, rightClick, key) {
    //取消冒泡事件
    e.stopPropagation(); 
    
    var order = rightClick ? 'mouseRDown' : 'mouseLDown';
    try {
        window.external.SyncRequest(order, key);
    } catch (e) {}  
},
/**
 * 处理右键点击
 * @param  {string} id elementid
 * @return {void}    无
 */
skin.rightButton = function (id) {
    if (event.button == 2) {
       skin.execMouseDown(event, true, id);
    }
},
/**
 * 执行命令
 * @param {string} 命令名称
 * @param {string} 值
 * @return string | void
 */
skin.execOrder = function (order, key) {
    var info = '';
    try { 
        key = (key.length == 0 ? '0' : key); 
        info = window.external.SyncRequest(order, key);
    } catch (e) {       
    } 
    return info;
},
/**
 * 执行客户端命令,获取参数
 * @param  {string} order 命令名称
 * @param  {string} param 参数
 * @return {void|object}       无|-
 */
skin.execSync = function (order, param) {
    try {
        if (window.external.SyncRequest) {
            return window.external.SyncRequest(order, param);
        } 
    } catch (e) {
        return '';
    }
    return '';
},
//获取RD数据status,null 时返回当前状态
/**
 * 设置icon状态
 * @param  {string} id  icon的id
 * @param  {string} key 命令
 * @return {void}     无
 */
skin.getExecStatus = function (id, key) {  
    if (typeof skin.g(id) == 'string') {
        return;
    }
    var statu = skin.execSync('getButtonState', key) || skin.g(id).getAttribute('statu'); 
    return statu;
},
/**
 * 初始输入法状态  
 * 参数:0 (中英文切换) 返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换) 返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点) 返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)            返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
skin.setIMEStatus = function () { 
    setButtonState('0', skin.getExecStatus('language', '0'));    
    setButtonState('1', skin.getExecStatus('characters', '1'));  
    setButtonState('2', skin.getExecStatus('punctuation', '2')); 
    setButtonState('4', skin.getExecStatus('login', '4'));   
},
/**
 * 绑定输入法icon点击/hover等事件
 * @return {void} 无
 */
skin.bindEvent = function () {
    var icons = skin.g('iconEvent').getElementsByTagName('img');
    for (var i = 0, len = icons.length; i < len; i++) {        
        icons[i].onclick = function () { 
            skin.execMouseDown(event, false, this.getAttribute('key'));
        }
        icons[i].onmouseup = function () { 
            skin.rightButton(this.getAttribute('key'));
        }
        icons[i].onmouseover = function () { 
            skin.execOrder('mouseOver', this.getAttribute('key'));
        }
        icons[i].onmouseout = function () { 
            skin.execOrder('mouseOver', 'null');
        }
    }
    document.onclick  =function () {
        skin.execMouseDown(event, false, 'null');    
    }
    
    document.onmouseup =function () {  
        skin.rightButton('null'); 
    }
},
/**
 * 设置皮肤动画
 */
skin.setAnimate = function () {
    var date = new Date();
    skin.hour = date.getHours();
    // 鼠标移到花朵上
    skin.g('fall').onmouseover = function () {
        skin.setFlower('fall');        
    }
    // 设置定时动画
    skin.setBoxBgLoop(7000);
    // 报时动画
    skin.tellTime(500);
},
/**
 * 设置花开花落
 * @param {string} act fall|blow 花开|花落
 */
skin.setFlower = function (act) {
    if (skin.flower) {
        window.clearTimeout(skin.flower);
        skin.flowerStatu = 0;
    } 
    if (act == 'fall') {    
        skin.g('setFlower').innerHTML = '';     
        skin.g('setFlower').innerHTML = '<div id="flower" class="flower pos flower-drop"></div>';
        skin.flower = window.setTimeout(function () {
             skin.g('flower').className = "flower pos flower-blow";
             skin.flowerStatu = 1;
             window.setTimeout(function () {
                skin.flowerStatu = 0;
             }, 2001);
        }, 1800);        
    } else {
        skin.g('setFlower').innerHTML = '<div id="flower" class="flower pos flower-blow"></div>';
    }
},
/**
 * 设置定时动画
 * @param {number} timer 设置动画间隔毫秒数
 * @return {void}       无
 */
skin.setBoxBg = function (timer) {    
    if (skin.flowerStatu) {

    }
    if (skin.boxBg) {
        window.setInterval(skin.boxBg);
    }
    var html = [];
    skin.boxBg = window.setInterval(function (){ 
        skin.g('iterateBg').innerHTML = '';
        html.length = 0;
        html[html.length] = '<div id="boxBg">';
        html[html.length] = '    <div id="blow" class="bg pos"></div>';
        html[html.length] = '</div>';         
        html[html.length] = '<div class="butterfly-left pos"></div>';
        html[html.length] = '<div id="setFlower">';
        html[html.length] = '    <div id="flower" class="flower pos flower-blow"></div>';
        html[html.length] = '</div>';
        skin.g('iterateBg').innerHTML = html.join(" ");
     }, timer);
   
},
/**
 * 设置背景定时效果(叶子抖动)
 * @param {number} timer 指定时间间隔
 * @return {void}       无
 */
skin.setBoxBgLoop = function (timer) {
    clearTimeout(skin.bgloop);
    skin.bgloop = window.setTimeout(function () {
        skin.g('blow').className = "bg pos bg-delay";
        skin.clearBoxBgLoop(1800);
    }, timer);
},
/**
 * 删除背景定时效果(叶子抖动; 删除是为了下一次的增加)
 * @param  {number} timer 指定时间间隔
 * @return {void}       无
 */
skin.clearBoxBgLoop = function (timer) {
    clearTimeout(skin.clearBgLoop);
    skin.clearBgLoop = window.setTimeout(function () {
        skin.g('blow').className = "bg pos bg-stay";        
        skin.setBoxBgLoop(5000);
    }, timer);
},
/**
 * 设置报时动画
 * @param  {number} timer 校准时间的毫秒数
 * @return {void}       无
 */
skin.tellTime = function (timer) {
    var date = 0;
    skin.setTellTimeInterval = window.setInterval(function () { 
        date = new Date();
        if (skin.hour != date.getHours()) { 
            skin.hour = date.getHours();
            skin.g('oclock').innerHTML = '<div class="oclock pos"></div>';
        }
    }, timer);
}
// 供客户端调用
function setButtonState(key, statu) { 
    var status = config.buttonstatus;
    var id = '';
    key = key || '0';
    id = status[key].id;
    if (typeof skin.g(id) == 'string') {
        return;
    }
    statu =  statu || (skin.g(id).getAttribute('statu') == '0' ? '1' : '0');     
    skin.g(id).src = 'images/icons/' + status[key][statu];
    skin.g(id).setAttribute ('statu', statu);        
}



